#!/usr/bin/ruby -Ks
#
#  YKLook
#        Copyright (C) 2009-2010 YorozuKotowariYa Ltd.

if ARGV.size() != 1
	STDERR.puts("need a filename")
	exit
end

YK_TITLE = "Java NXΉ\"

def mTrimBlank( prmSource )
	idx = 0
	while idx < prmSource.size()
		if prmSource[idx] != 0x20 and prmSource[idx] != 0x09 and
			prmSource[idx] != 0x0d and prmSource[idx] != 0x0a
			if prmSource[idx] != 0x81
				break
			end
			if (idx + 1) >= prmSource.size()
				STDERR.puts("ill-kanji")
				STDERR.puts("str=(" + prmSource + ')')
				raise
			end
			if prmSource[idx+1] != 0x40
				break
			end
			idx += 1
		end
		idx += 1
	end
	if idx >= prmSource.size()
		return ''
	end
	j = prmSource.size() - 1
	while j >= 0
		if prmSource[j] != 0x20 and prmSource[j] != 0x09 and
			prmSource[j] != 0x0d and prmSource[j] != 0x0a
			if j < 1
				break
			end
			if prmSource[j-1] != 0x81 or prmSource[j] != 0x40
				break
			end
			j -= 1
		end
		j -= 1
	end
	if j < 0
		STDERR.puts('error fatal')
		exit
	end
	return prmSource[idx..j]
end
def mScanRaw( prmLines )
	hash = { }
	flg = false
	cls = nil
	idx = 0
	while idx < prmLines.size()
		str = prmLines[idx]
		case str[0,1]
		when 'Y'
			if str[0,6] != 'YKLook'
				STDERR.puts('illegal clas name')
				exit
			end
			flg = true
			cls = mTrimBlank( str )
			if hash.include?(cls)
				STDERR.puts('dup class name')
				exit
			end
			hash[cls] = []
		when 'y'
			flg = false
			cls = nil
		when "\n"
			flg = false
			cls = nil
		when "\t"
			if flg
				if not cls
					STDERR.puts('illegal format -- no class --')
					exit
				end
				ary = hash[cls]
				if not ary.kind_of?(Array)
					STDERR.puts('pgm error array')
					exit
				end
				ary << mTrimBlank( str )
			end
		when '#'
			# nothing
		else
			STDERR.puts('illegal lines ' + idx.to_s())
			exit
		end
		idx += 1
	end
	return hash
end
def mScanYk( prmRaw )
	hash = { }
	prmRaw.each() do |key,val|
		ary = [ '' ]
		hash[key] = ary
		val.each() do |str|
			case true
			when str[0,1] == 'j'
				ary << str
				ary << (str.split('.')[-1])
			when (str[0,2] == 'i' or str == 'Ȃ')
				ary[0] = ary[0] + str
			else
				STDERR.puts('illegal string')
				STDERR.puts('key=(' + key + ')')
				STDERR.puts('str=(' + str + ')')
				exit
			end
		end
	end
	return hash
end
def mScanJava( prmYk )
	hash = { }
	prmYk.keys().sort().each() do |key|
		val = prmYk[key]
		idx = 1
		while idx < val.size()
			jav = val[idx+1]
			ary = hash[jav]
			if ary
				if ary[0] != val[idx]
					STDERR.puts('illegal java class package')
					exit
				end
			else
				ary = [ val[idx] ]
				hash[jav] = ary
			end
			ary << key
			ary << val[0]
			idx += 2
		end
	end
	return hash
end
def mPutJavaToYk( prmHash )
	puts('<div style="margin-left: 30px">')
	puts('Java NXɃ}EXJ[\uƊSC\܂ <br /> <br />')
	puts('<table border=1 cellpadding=4 cellspacing=0>')
	puts('  <tr>')
	puts('    <th nowrap> Java NX </th>')
	puts('    <th>  YKLook NX </th>')
	puts('  </tr>')
	prmHash.keys().sort().each() do |key|
		ary = prmHash[key]
		puts("  <tr>\n    <td>")
		puts('<table width="100%" border=0 cellpadding=0 cellspacing=0>')
		puts('  <tr>')
		puts('    <td> <a name="' + key + '" title="' + ary[0] + '">' +
				key + '</a> </td>')
		# puts('    <td align=right> \bhΉ </td>')
		puts('    <td align=right> &nbsp; </td>')
		puts('  </tr>')
		puts('</table>')
		puts("    </td>\n    <td>")
		puts('<table width="100%" border=0 cellpadding=0 cellspacing=0>')
		idx = 1
		while idx < ary.size()
			puts('  <tr>')
			puts('    <td> <a href="cla-' + ary[idx] + '.html"> ' +
				ary[idx] + ' </a> </td>')
			puts('    <td align=right> <a href="#' +
					ary[idx] + '"> t </a> </td>')
			puts('  </tr>')
			if ary[idx+1].size() > 0
				puts('  <tr>')
				puts('    <td colspan=2> ' + ary[idx+1] + ' </td>')
				puts('  </tr>')
			end
			idx += 2
		end
		puts('</table>')
		puts("    </td>\n  </tr>")
	end
	puts('</table>')
	puts('</div>')
end
def mPutYkToJava( prmHash )
	puts('<div style="margin-left: 30px">')
	puts('Java NXɃ}EXJ[\uƊSC\܂ <br /> <br />')
	puts('<table border=1 cellpadding=4 cellspacing=0>')
	puts('  <tr>')
	puts('    <th nowrap>  YKLook NX </th>')
	puts('    <th> Java NX </th>')
	puts('  </tr>')
	prmHash.keys().sort().each() do |key|
		ary = prmHash[key]
		puts("  <tr>\n    <td>")
		puts('<table width="100%" border=0 cellpadding=0 cellspacing=0>')
		puts('  <tr>')
		puts('    <td> <a name="' + key + '" href="cla-' + key + '.html"> ' +
				key + ' </a> </td>')
		# puts('    <td align=right> \bhΉ </td>')
		puts('    <td align=right> &nbsp; </td>')
		puts('  </tr>')
		puts('</table>')
		puts("    </td>\n    <td>")
		puts('<table width="100%" border=0 cellpadding=0 cellspacing=0>')
		idx = 1
		while idx < ary.size()
			puts('  <tr>')
			puts('    <td> <span title="' + ary[idx] + '">' +
					ary[idx+1] + '</span> </td>')
			puts('    <td align=right> <a href="#' +
					ary[idx+1] + '"> t </a> </td>')
			puts('  </tr>')
			idx += 2
		end
		if ary[0].size() > 0
			puts('  <tr>')
			puts('    <td colspan=2> ' + ary[0] + ' </td>')
			puts('  </tr>')
		end
		puts('</table>')
		puts("    </td>\n  </tr>")
	end
	puts('</table>')
	puts('</div>')
end
def mPutHeader()
	print <<"EOF"
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=shift_jis">
<title> YKLook  NX  #{YK_TITLE} </title>
</head>




<!--  
                    ێS҂ւ̓`

                    ̃t@C𒼐ڕҏW_I@ij
  -->





<body bgcolor="#ffffff">
<table width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr>
    <td>
      <a href="../index.html"> YKLook </a> 
      <a href="index.html"> NX </a> 
      <a name="top"> #{YK_TITLE} </a>
    </td>
    <td align=right>
      <a href="cla-list-abc.html" title="NXꗗi`abj"> O </a>
      <!-- kanji sp --> @ <!-- kanji sp -->
      <a href="../man-rapid/index.html" title="t^FRuby ̑킩">  </a>
    </td>
  </tr>
</table>
EOF
end
def mPutLinkBar()
	print <<"EOF"
<table bgcolor="#ccffcc" width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr nowrap>
    <td>
      <!-- kanji sp --> @ <!-- kanji sp -->
    </td>
    <td> &nbsp; </td>
  </tr>
</table>
EOF
end
def mPutFooter()
	print <<"EOF"
<table width="100%" border=0 cellpadding=0 cellspacing=0>
  <tr>
    <td>
      <a href="../index.html"> YKLook </a> 
      <a href="index.html"> NX </a> 
      <a href="#top" title="̃y[W̐擪"> #{YK_TITLE} </a>
    </td>
    <td align=right>
      <a href="cla-list-abc.html" title="NXꗗi`abj"> O </a>
      <!-- kanji sp --> @ <!-- kanji sp -->
      <a href="../man-rapid/index.html" title="t^FRuby ̑킩">  </a>
    </td>
  </tr>
</table>
<br>
<hr>
<center>
  <span title="iLj낸Ƃ">
    Copyright (c) 2003-2010 YorozuKotowariYa Ltd.
  </span>
</center>

<!-- 

Copyright (c) 2003-2010 YorozuKotowariYa Ltd.
iLj낸Ƃ

designed by Hatashima Koji
written by Hatashima Koji
݌vF_
F_

 -->

</body>
</html>
EOF
end
def mPutSubTitle( prmLinkLabel, prmDisplayLabel )
	print <<"EOF"
<br />
<table bgcolor="#dddddd" width="100%" cellpadding=4>
<tr><td id="#{prmLinkLabel}"> #{prmDisplayLabel} </td></tr>
</table>
<br />
EOF
end
def mDumpHash( prmHash )
	puts('--------------------------------------------------------------')
	prmHash.each() do |key,val|
		puts('key=(' + key + ') len=' + val.size().to_s())
		val.each_with_index() do |str,idx|
			puts('val[' + idx.to_s() + ']=(' + str + ')')
		end
	end
end

#
# main
#
lines = File.readlines( ARGV[0] )
hash_raw  = mScanRaw( lines )
hash_yk   = mScanYk( hash_raw )
hash_java = mScanJava( hash_yk )

mPutHeader()
mPutLinkBar()
print <<"EOF"
<br>
<h1> #{YK_TITLE} </h1>
<br>
<ul>
  <li> <a href="#javaToYk"> Java NX YKLook NX </a>
  <li> <a href="#YkToJava"> YKLook NX Java NX </a>
</ul>
<br>
EOF
mPutSubTitle( 'javaToYk', 'Java NX YKLook NX' )
mPutJavaToYk( hash_java )
puts('<br>')
mPutSubTitle( 'YkToJava', 'YKLook NX Java NX' )
mPutYkToJava( hash_yk )
puts('<br> <br>')
mPutLinkBar()
mPutFooter()

# mDumpHash( hash_yk )
# mDumpHash( hash_java )

#
# end
